/***************************************************************************
                          pagerank_opt.h  -  description
                             -------------------
    begin                : Mon Mr 10 2003
    copyright            : (C) 2003 by Ingmar Bauer
 ***************************************************************************/

#ifndef PAGERANK_OPT_H
#define PAGERANK_OPT_H

/**Optimized Pagerank calculation
  *@author Ingmar Bauer (ingmar@metacrawler.de)
  */
class pagerank_opt {
public:
  pagerank_opt(datasource &ds, float c, float eps);
  ~pagerank_opt();

  vector<float> calc(void);
  void modifyZeroRows(void);
  void normalize(float);

private:
  float c;
  float eps;
  unsigned int size;		// copy of matrix size

  datasource *ds;	//
  matrix<float> *a;	// pointer to the original matrix

  vector<float> src;	// computing vectors
  vector<float> dest;
};

#endif
