#!/usr/bin/perl

#
# Ingmar Bauer
#

#
# this one gets the links out of the downloaded documents
#

use strict;
use DBI;

my $dbuser = 'root';
my $dbpasswd = '';
my $dbname = 'testsuite_c64';
my $dbpages = 'pages';
my $dblnk = 'lnk';

my $db_driver;
my $dbh;

sub connectDB() {
    # database connection
    $db_driver = DBI->install_driver('mysql');
    if(!$db_driver) {
	print("Error connecting to database.\n");
	return 0;
    }

    $dbh = $db_driver->connect($dbname, $dbuser, $dbpasswd);
    if(!$dbh) {
	print("Error connecting to database.\n");
	return 0;
    }
    return 1;
}

sub disconnectDB() {
    $dbh->disconnect();
}


sub creatLnk() {
    my $host;
    my $sql_statement;
    my $sth;
    my @row;
    
    my $doc_id;
    my $doc_data;
    
    my $link;
    my $text;
    
    my @lnkids;
    my $lnkno = 0;
    
    my $stop = 0;
            
    $sql_statement = "SELECT doc_id, doc_data FROM pages WHERE doc_id>=0";
    $sth = $dbh->prepare($sql_statement) or die $dbh->errstr();
    $sth->execute() or die $dbh->errstr();
    
    while( (@row = $sth->fetchrow()) && !$stop ) {
	$doc_id = $row[0];
	$doc_data = $row[1];
	
	#
	$sql_statement = "SELECT url FROM url WHERE id=$doc_id";
	my $sth2 = $dbh->prepare($sql_statement);
	$sth2->execute() or die $dbh->errstr();
	
	my @row2 = $sth2->fetchrow();
	#$row2[0] =~ m|(http:\/\/.+?)[\/\?\:]|is;
	#$host = $1;
	$host = $row2[0];
	$host =~ s|\+|\\\+|isg;
	$sth2->finish();
	
	print "\n\nHost: $host\n";
	#
	
	#while($doc_data =~ m|<a[^>]*href=[\"/\']*(http:\/\/.+?)[\"/\']*[^>]*>|isg) {
	while($doc_data =~ m|<a[^>]+href=[\"\'](http:\/\/.+?)[\"\'].*?>(.*?)</a>|isg) {
	    $link = $1;
	    $text = $2;
	    
	    if($link =~ m|^$host|is) {
		print "\n\n... local link found: $link\n";
		next;
	    } else {
	        $text =~ s|<.+?>||isg;
	    
		print "Absolute link: $link\n";
		
		$sql_statement = "SELECT id FROM url WHERE url=".$dbh->quote($link);
		my $sth2 = $dbh->prepare($sql_statement);
		$sth2->execute() or die $dbh->errstr();
		my @row = $sth2->fetchrow();
		if($row[0]) {
		    $lnkids[$lnkno++] = $row[0];
		}
		$sth2->finish();
	    }
	}
	#$stop = 1;
	#
	# save data
	if(scalar(@lnkids) > 0) {
	    $sql_statement = "INSERT INTO lnk (src_id, lnk_ids) VALUES($doc_id, ";
	    my $help = "";
	    foreach $a (@lnkids) {
		$help .= "$a,";
	    }
	    $help = substr($help, 0, length($help)-1);
	
	    $sql_statement .= $dbh->quote($help);
	    $sql_statement .= ")";
    	    
	    print "\nSQL: $sql_statement\n";
	    $dbh->do($sql_statement) or die $dbh->errstr();
	    
	    # reinit
	    @lnkids = ();
	    $lnkno = 0;
	}
    }
    
    $sth->finish();
    
    #print "\n\nLinks: $doc_id -> ";
    #foreach $a (@lnkids) {
#	print "$a, ";
#    }
#    print "\n";
    return;
}
    
        
#
# main
#


# build up a URL-Database using Results from metacrawler.de
# first get a result set and save the given links into url-database
# use keywordlist for that...
# ca. 150 results per keyword -> 40 keywords -> 6000 pages

if(!&connectDB()) {
    print "Error connecting to database!\n";
    exit(0);
}

&creatLnk();

&disconnectDB();
print("done.\n");

exit(1);
