#!/usr/bin/perl -w

#
# Ingmar Bauer
#

use strict;
use DBI;


# Datenbankroutinen
my $dbname = 'testsuite_c64';
my $dbuser   = 'root';
my $dbpasswd = '';
my $driver;
my $dbh;
    
$driver = DBI->install_driver('mysql');
if(!$driver) {
    return(0);
}

$dbh = $driver->connect($dbname, $dbuser, $dbpasswd);
if(!$dbh) {
    return(0);
}


# Fileroutinen

open(f_index, ">c64.inv.idx") or die("index not open");
open(f_refs, ">c64.inv.ref") or die("refs not open");
#open(f_url, ">test.inv.url") or die("urls not open");


# copy process
my $src_id;
my @lnk_ids = ();
my $url;

#my @data = ([]);
my %data;

my $sql1 = "SELECT u.id,u.url FROM url AS u ORDER BY u.id";
my $sth = $dbh->prepare($sql1);
if($sth) {
    $sth->execute();
    
    my @row = ();
    while( (@row = $sth->fetchrow())) {
	$src_id = $row[0];
	$url = $row[1];
	
	# get refs
	@lnk_ids = ();
	my $sql2 = "SELECT lnk_ids FROM lnk WHERE src_id=$src_id";
	my $sth2 = $dbh->prepare($sql2);
	$sth2->execute();
	if( (my @row2 = $sth2->fetchrow()) ) {
	    @lnk_ids = split(/,/, $row2[0]);
	}
	$sth2->finish();
	
	#print "processing $src_id\n";
	
	my $id;
	foreach $id (@lnk_ids) {
	    #print "$id, ";
	    
	    #push(@{$data[$id]}, $src_id);
	    push(@{$data{$id}}, $src_id);
	    
	}
	
	# write out to file

	#my $id;
	#foreach $id (@lnk_ids) {	
#	    print f_refs pack("I", $id);
#	}
	
	#print f_url "$url\n";
    }
    $sth->finish();

    print "lenght of entry 1: ".scalar(@{$data{1}})."\n";
    my $id;
    foreach $id (@{$data{1}}) {
	print "$id, ";
    }
    print "\n";
    
    
    
    my $key;
    my $value;
    
    while( ($key, $value) = each(%data)) {
    
    if($key == 1) {
	print "key: $key\n";
	print "offset in idx: ".tell(f_index);
	
    	#foreach my $id (@{$value}) { #(@{$data{$key}}) {
	#    # write out that data
	#    print "$id, ";
	#}
	print "\n";
    }
    
	print f_index pack("I", $key-1);
	print f_index pack("I", tell(f_refs));
	print f_index pack("S", scalar(@{$value}));
	print f_index pack("I", 0);
    
	foreach my $id (@{$value}) { #(@{$data{$key}}) {
	    # write out that data
	    print f_refs pack("I", $id-1);
	}
	#print f_url "$url\n";
    }
}










close(f_index);
close(f_refs);
#close(f_url);
$dbh->disconnect();

